/* zlacrt.f -- translated by f2c (version 19941103).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int zlacrt_(n, cx, incx, cy, incy, c, s)
integer *n;
doublecomplex *cx;
integer *incx;
doublecomplex *cy;
integer *incy;
doublecomplex *c, *s;
{
    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    doublecomplex z__1, z__2, z__3;

    /* Local variables */
    static integer i;
    static doublecomplex ctemp;
    static integer ix, iy;


/*  -- LAPACK auxiliary routine (version 2.0) -- */
/*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd., */
/*     Courant Institute, Argonne National Lab, and Rice University */
/*     October 31, 1992 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  ZLACRT applies a plane rotation, where the cos and sin (C and S) are 
*/
/*  complex and the vectors CX and CY are complex. */

/*  Arguments */
/*  ========= */

/*  N       (input) INTEGER */
/*          The number of elements in the vectors CX and CY. */

/*  CX      (input/output) COMPLEX*16 array, dimension (N) */
/*          On input, the vector X. */
/*          On output, CX is overwritten with C*X + S*Y. */

/*  INCX    (input) INTEGER */
/*          The increment between successive values of CY.  INCX <> 0. */

/*  CY      (input/output) COMPLEX*16 array, dimension (N) */
/*          On input, the vector Y. */
/*          On output, CY is overwritten with -S*X + C*Y. */

/*  INCY    (input) INTEGER */
/*          The increment between successive values of CY.  INCX <> 0. */

/*  C       (input) COMPLEX*16 */
/*  S       (input) COMPLEX*16 */
/*          C and S define a complex rotation */
/*             [  C   S  ] */
/*             [ -S   C  ] */
/*          where C*C + S*S = 1.0. */

/* ===================================================================== 
*/

/*     .. Local Scalars .. */
/*     .. */
/*     .. Executable Statements .. */

    /* Parameter adjustments */
    --cy;
    --cx;

    /* Function Body */
    if (*n <= 0) {
	return 0;
    }
    if (*incx == 1 && *incy == 1) {
	goto L20;
    }

/*     Code for unequal increments or equal increments not equal to 1 */

    ix = 1;
    iy = 1;
    if (*incx < 0) {
	ix = (-(*n) + 1) * *incx + 1;
    }
    if (*incy < 0) {
	iy = (-(*n) + 1) * *incy + 1;
    }
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	i__2 = ix;
	z__2.r = c->r * cx[i__2].r - c->i * cx[i__2].i, z__2.i = c->r * cx[
		i__2].i + c->i * cx[i__2].r;
	i__3 = iy;
	z__3.r = s->r * cy[i__3].r - s->i * cy[i__3].i, z__3.i = s->r * cy[
		i__3].i + s->i * cy[i__3].r;
	z__1.r = z__2.r + z__3.r, z__1.i = z__2.i + z__3.i;
	ctemp.r = z__1.r, ctemp.i = z__1.i;
	i__2 = iy;
	i__3 = iy;
	z__2.r = c->r * cy[i__3].r - c->i * cy[i__3].i, z__2.i = c->r * cy[
		i__3].i + c->i * cy[i__3].r;
	i__4 = ix;
	z__3.r = s->r * cx[i__4].r - s->i * cx[i__4].i, z__3.i = s->r * cx[
		i__4].i + s->i * cx[i__4].r;
	z__1.r = z__2.r - z__3.r, z__1.i = z__2.i - z__3.i;
	cy[i__2].r = z__1.r, cy[i__2].i = z__1.i;
	i__2 = ix;
	cx[i__2].r = ctemp.r, cx[i__2].i = ctemp.i;
	ix += *incx;
	iy += *incy;
/* L10: */
    }
    return 0;

/*     Code for both increments equal to 1 */

L20:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	i__2 = i;
	z__2.r = c->r * cx[i__2].r - c->i * cx[i__2].i, z__2.i = c->r * cx[
		i__2].i + c->i * cx[i__2].r;
	i__3 = i;
	z__3.r = s->r * cy[i__3].r - s->i * cy[i__3].i, z__3.i = s->r * cy[
		i__3].i + s->i * cy[i__3].r;
	z__1.r = z__2.r + z__3.r, z__1.i = z__2.i + z__3.i;
	ctemp.r = z__1.r, ctemp.i = z__1.i;
	i__2 = i;
	i__3 = i;
	z__2.r = c->r * cy[i__3].r - c->i * cy[i__3].i, z__2.i = c->r * cy[
		i__3].i + c->i * cy[i__3].r;
	i__4 = i;
	z__3.r = s->r * cx[i__4].r - s->i * cx[i__4].i, z__3.i = s->r * cx[
		i__4].i + s->i * cx[i__4].r;
	z__1.r = z__2.r - z__3.r, z__1.i = z__2.i - z__3.i;
	cy[i__2].r = z__1.r, cy[i__2].i = z__1.i;
	i__2 = i;
	cx[i__2].r = ctemp.r, cx[i__2].i = ctemp.i;
/* L30: */
    }
    return 0;
} /* zlacrt_ */

